{ This is a descendant of a TListBox that makes use of a TImageList.
Now, Drawing Bitmaps into a ListBox wil be much easier.
This component is freeware. Do with it what ever you want. but 
I will not be held liable for any damage it does (you have the source)

To make use of the features of TSKDrawList, The Style
must be set to OwnerDraw.

To use, just add your items to as you would a normal
ListBox. Then in the 'SKDrawList1DrawItem' event,
You set the image to draw like so :

SKDrawList1.NewImageIndex := Index;

For this example, I just used the ItemIndex of the ListBox
itself to choose an image. Yours most likely will be
different.

For any questions or comments I can be reached at:
 robert@alpine.net }

unit SKDrawList;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, DsgnIntf, StdCtrls;

type
  TAbout = class(TPropertyEditor)
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
    function GetValue: string; override;
  end;

  TSKDrawList = class(TListBox)
  private
    FAbout: TAbout;
    FImageIndex : Integer;
    FSKImageList : TImageList;
    FSKDrawList : TSKDrawList;
    Function GetImageList : TImageList;
    Procedure SetImageList(Value : TImageList);
    Function GetImageIndex : Integer;
    Procedure DrawImage(Index, NewIndex : Integer; Rect: TRect);
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    Procedure DrawItem(Index: Integer; Rect: TRect; State: TOwnerDrawState);  override;
    Property NewImageIndex : Integer read FImageIndex write FImageIndex Stored True;
  published
    property About: TAbout read FAbout write FAbout;
    property ImageList : TImageList read GetImageList write SetImageList Stored True;
  end;

procedure Register;

 

implementation

procedure TAbout.Edit;
begin
  Application.MessageBox('TSKDrawList component v1.00 (C) 1998 Robert Jones. This component is freeware.',
                         'About TSKDrawList Component', MB_OK + MB_ICONINFORMATION);
end;

function TAbout.GetAttributes: TPropertyAttributes;
begin
  Result:= [paMultiSelect, paDialog, paReadOnly];
end;

function TAbout.GetValue: string;
begin
  Result:= '(about)';
end;

Procedure TSKDrawList.DrawImage(Index, NewIndex : Integer; Rect: TRect);
 Var
 NewBitMap : TBitmap;
Begin
  NewBitMap := TBitMap.Create;
    FSKImageList.GetBitmap(GetImageIndex, NewBitmap);
    With Canvas Do
     Begin
        FillRect(Rect);
        Draw(Rect.Left -1, Rect.Top + 0, NewBitmap);
        TextOut(Rect.Left + 2 + NewBitmap.Width, Rect.Top + 2,
        Items.Strings[Index]);
     End;
   NewBitMap.Free;
End;

Procedure TSKDrawList.SetImageList(Value : TImageList);
Begin
  If Value <> FSKImageList Then
    FSKImageList := Value;
If Not Assigned(FSKImageList) Then
  FSKImageList := Nil;
End;

Function TSKDrawList.GetImageList : TImageList;
Begin
 Result := FSKImageList;
End;

Function TSKDrawList.GetImageIndex : Integer;
Begin
 Result := FImageIndex;
End;

procedure TSKDrawList.DrawItem(Index: Integer; Rect: TRect; State: TOwnerDrawState);
begin
 Inherited;
  DrawImage(Index, FImageIndex, Rect);
end;

constructor TSKDrawList.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  Style := lbOwnerDrawFixed;
  ControlStyle:= ControlStyle + [csAcceptsControls];
end;

Destructor TSKDrawList.Destroy;
Begin
 inherited Destroy;
End;

procedure Register;
begin
  RegisterComponents('SK', [TSKDrawList]);
  RegisterPropertyEditor(TypeInfo(TAbout), TSKDrawList, 'ABOUT', TAbout);
end;

end.
